<!DOCTYPE html>
<html lang="en">
  <head>
    <title>reveal.js showcase</title>

    <meta charset="utf-8" />
    <meta name="mobile-web-app-capable" content="yes" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />

    <link rel="icon" href="data:," />

    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/4.4.0/reset.min.css"
      integrity="sha512-Mjxkx+r7O/OLQeKeIBCQ2yspG1P5muhAtv/J+p2/aPnSenciZWm5Wlnt+NOUNA4SHbnBIE/R2ic0ZBiCXdQNUg=="
      crossorigin="anonymous"
      referrerpolicy="no-referrer"
    />
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/4.4.0/reveal.min.css"
      integrity="sha512-A5PKBHoJQHdKjxpwyV+VhMsK7L3MMV1Ch2++rS0bn3xX8+5qJb3WpPvwJH1eqb6iMRtotfiOO7Jhl1qQ02Rwuw=="
      crossorigin="anonymous"
      referrerpolicy="no-referrer"
    />
    <!-- "integrity" value intentionally omitted for dynamic theming demo -->
    <link
      id="theme"
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/4.4.0/theme/black.min.css"
      crossorigin="anonymous"
      referrerpolicy="no-referrer"
    />
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/4.4.0/plugin/highlight/monokai.min.css"
      integrity="sha512-z8wQkuDRFwCBfoj7KOiu1MECaRVoXx6rZQWL21x0BsVVH7JkqCp1Otf39qve6CrCycOOL5o9vgfII5Smds23rg=="
      crossorigin="anonymous"
      referrerpolicy="no-referrer"
    />

    <style>
      kbd {
        border-radius: 3px;
        border: 1px solid;
        padding-left: 6px;
        padding-right: 6px;
      }

      .reveal > .slides pre > code {
        font-size: 18px;
      }

      .big-button {
        cursor: pointer;
        font-size: 1.25rem;
        padding: 1rem;
        transition-duration: 0.15s;
      }

      .big-button:hover {
        background-color: #a0a0a0;
        border-radius: 8px;
      }

      .placeholder-img-fallback {
        background-color: var(--fallback-fill-color, hsl(0, 100%, 75%));
      }
    </style>
  </head>

  <body>
    <div class="reveal">
      <div class="slides">
        <section
          data-background-gradient="-webkit-radial-gradient(center, circle cover, #333333 0%, #101010 100%)"
        >
          <h1>reveal.js</h1>

          <h3>HTML Presentation Framework</h3>

          <p>
            <small>(use arrow keys to navigate and space bar to advance)</small>
          </p>
        </section>

        <section id="keyboard-shortcuts">
          <h2>Keyboard shortcuts</h2>

          <p>Type <kbd>?</kbd> (<kbd>Shift</kbd>+<kbd>/</kbd>)</p>
          <p><small>for a comprehensive list of keyboard shortcuts</small></p>

          <p>Enter fullscreen mode with <kbd>F11</kbd> or <kbd>F</kbd></p>
        </section>

        <section>
          <section id="vertical-slides-top">
            <h2>Vertical slides</h2>

            <p>For when you want to dive deep into a topic</p>
            <p>
              <small
                >Use up/down arrows to dive deeper (or
                <a
                  href="https://revealjs.com/vertical-slides/#navigation-mode"
                  rel="noopener noreferrer"
                  >space bar to advance</a
                >),
                <br />
                and left/right arrows to move onto the next topic</small
              >
            </p>

            <span
              class="navigate-down"
              style="cursor: pointer; font-size: 192px"
              >↓</span
            >
          </section>
          <section id="vertical-slides-middle">
            <h2>Some detailed info</h2>

            <p>
              You move onto the next topic at any time
              <br />
              with the left/right arrows
            </p>
          </section>
          <section id="vertical-slides-bottom">
            <h2>Some even more details</h2>

            <p>
              Perhaps some links to references
              <br />
              or further readings here
            </p>
          </section>
        </section>

        <section data-auto-animate id="code-snippet">
          <h2 data-id="code-title">Code snippets</h2>

          <pre data-id="code-animation">
            <code class="hljs cpp" data-trim data-line-numbers>
              <script type="text/template">
                #include <iostream>

                template <typename T>
                std::enable_if_t<std::is_integral<T>::value> func(T value) {
                  std::cout << "Integral: " << value << "\n";
                }

                template <typename T>
                std::enable_if_t<std::is_floating_point<T>::value> func(T value) {
                  std::cout << "Floating point: " << value << "\n";
                }

                int main() {
                  short s = 1;
                  int i = 2;
                  double d = 3.456;
                  float f = 7.890;

                  func(s);
                  func(i);
                  func(d);
                  func(f);

                  // Compile-time error, as expected
                  // int array[5] = {0};
                  // func(array);
                }
              </script>
            </code>
          </pre>

          <p>
            <small
              ><a
                href="https://tio.run/#%23lZA7T8MwEMd3f4pTWRqJtOVRHknIgoTEHokBUGScS7Dk2JbtIKoqX51gu0GdGLrd/3Hnn8y0TjvGpumMSyaGBqHgyjqDtC8JcdhrQZ033U6jpD1CVRLrmizz6kNgzdvaFdHgtubSYWeoKKoyy76oGLCEdpBsWUFUCewJQGwzNTgoClg8zzsZLIKOvRi8yUVOxpMZWqGo47KrtfI4p5A8zZsQN//l8Rn0lMvlfONTGQcWHuAi9zKk3IvLIBo1eD5ovL5aXW9vghf5oPXW7erufpOT4AUym@R/Iz@OzXFsk1her@FR9ZoLTB33n4HGKHMO1AJ@a2QOm0MpkFBj6O51@@5f22/G/BDEYzHxB8dp@mGtoJ2d0hcqxC8"
                title="C++ (gcc) – Try It Online"
                target="_blank"
                rel="noopener noreferrer"
                >Try it online!</a
              >
              <br />
              <br />
              Code highlighting by highlight.js in Monokai theme
            </small>
          </p>
        </section>

        <section>
          <section data-auto-animate id="code-snippet-animated">
            <h2 data-id="code-title">...with animations</h2>

            <pre data-id="code-animation">
              <!-- Note: first and last '|' highlights all lines -->
              <code class="hljs cpp" data-trim data-line-numbers="4,9|14-22|24-26|">
                <script type="text/template">
                  #include <iostream>

                  template <typename T>
                  std::enable_if_t<std::is_integral<T>::value> func(T value) {
                    std::cout << "Integral: " << value << "\n";
                  }

                  template <typename T>
                  std::enable_if_t<std::is_floating_point<T>::value> func(T value) {
                    std::cout << "Floating point: " << value << "\n";
                  }

                  int main() {
                    short s = 1;
                    int i = 2;
                    double d = 3.456;
                    float f = 7.890;

                    func(s);
                    func(i);
                    func(d);
                    func(f);

                    // Compile-time error, as expected
                    int array[5] = {0};
                    func(array);
                  }
                </script>
              </code>
            </pre>

            <p>Use <kbd>Alt</kbd> + arrow key to skip animated highlighting</p>
          </section>
          <section data-auto-animate id="code-snippet-animated-annotated">
            <h2 data-id="code-title">...with animations</h2>

            <pre>
              <code class="hljs python" data-trim data-noescape data-line-numbers>
                <span class="fragment fade-in-then-semi-out" data-fragment-index="2">def main():</span>
                    <span class="fragment fade-in-then-semi-out" data-fragment-index="2">print("Hello, World!")</span>

                <span class="fragment fade-in-then-semi-out" data-fragment-index="1">if __name__ == "__main__"</span>
                    <span class="fragment fade-in-then-semi-out" data-fragment-index="1">main()</span>
              </code>
            </pre>

            <p>
              <span class="fragment fade-out" data-fragment-index="1"
                >With some more effort, comments can be matched with the code
                animation</span
              >
              <br />
              <span
                class="fragment semi-fade-out current-visible"
                data-fragment-index="1"
                >Prevents running code when imported as a script</span
              >
              <br />
              <span
                class="fragment semi-fade-out current-visible"
                data-fragment-index="2"
                >The main code to run</span
              >
            </p>
          </section>
        </section>

        <section id="katex" data-menu-title="KaTeX">
          <h2>\(\KaTeX\)</h2>

          <p>
            <small
              >A math typesetting library for the web (<a
                href="https://katex.org/docs/supported.html"
                rel="noopener noreferrer"
                >supported features</a
              >)
            </small>
          </p>

          <!-- prettier-ignore -->
          \[
            \underbrace{
              H(n) = \sum_{k = 1}^{n}{\frac{1}{k}}
            }_{\mathclap{n\text{-th harmonic number}}}
          \]
        </section>

        <section>
          <section data-markdown id="markdown">
            <textarea data-template data-noescape>
              ## Markdown support

              <!-- Warning: Markdown is not parsed correctly if there is a newline after <small> -->
              <small>Content can be written in Markdown ([docs](https://revealjs.com/markdown/))</small>

              ```html [|1,9|4,5,8]
              <section data-markdown>
                ## Markdown support

                <!-- HTML can be interleaved with Markdown -->
                <small>
                  Content can be written in Markdown
                  ([docs](https://revealjs.com/markdown/))
                </small>
              </section>
              ```
            </textarea>
          </section>
          <section data-markdown id="presentation-essentials">
            <textarea data-template data-noescape>
              ## Presentation essentials

              <br />

              1. ordered list item
              1. ordered list item

              <br />
              <br />

              | Column A     | Column B |      Column C |
              | ------------ | :------: | ------------: |
              | left-aligned | centered | right-aligned |
              | This         |   is a   |         table |

              <br />

              - unordered list item
              - unordered list item
            </textarea>
          </section>
        </section>

        <section>
          <section id="image-stacking">
            <h2>Piece-by-piece stacking</h2>

            <p>Emphasize with examples</p>

            <div class="r-stack">
              <img
                class="placeholder-img-fallback"
                style="--fallback-fill-color: hsl(240, 100%, 75%)"
                src="https://picsum.photos/seed/stacked-1/450/300"
                alt="Arbitrary wide image"
                width="450"
                height="300"
              />
              <img
                class="fragment placeholder-img-fallback"
                style="--fallback-fill-color: hsl(210, 100%, 75%)"
                src="https://picsum.photos/seed/stacked-2/300/450"
                alt="Arbitrary tall image"
                width="300"
                height="450"
              />
              <img
                class="fragment placeholder-img-fallback"
                style="--fallback-fill-color: hsl(270, 100%, 75%)"
                src="https://picsum.photos/seed/stacked-3/400"
                alt="Arbitrary square image"
                width="400"
                height="400"
              />
            </div>
          </section>
          <section id="fragments">
            <h2>Fragments</h2>

            <p>
              Sometimes you want to
              <span class="fragment fade-in-then-semi-out"
                ><u>fill in the blank</u></span
              >
              <span class="fragment"
                ><!-- intentionally empty fragment to separate fade out and highlight effects --></span
              >
              <br />
              or
              <span class="fragment highlight-blue">draw attention</span> to
              something
              <br />
              <span class="fragment fade-in"
                >or give one last unexpected item</span
              >
            </p>
          </section>
        </section>

        <section>
          <section id="config">
            <h2>Configuration</h2>

            <p class="r-fit-text">
              <a href="https://revealjs.com/config/" rel="noopener noreferrer"
                >reveal.js settings</a
              >
              can be overriden through the URL
            </p>

            <script>
              function setRevealJsConfig(newSettings) {
                const newUrl = new URL(window.location.href);
                newUrl.search =
                  "?" + new URLSearchParams(newSettings).toString();

                window.history.replaceState(null, "", newUrl.href);

                Reveal.configure(newSettings);
              }
            </script>

            <button
              class="big-button"
              onclick='setRevealJsConfig({
                  controls: true,
                  progress: true,
                  slideNumber: "c/t",
                })'
            >
              Use original configuration
            </button>
            <button
              class="big-button"
              onclick="setRevealJsConfig({
                  controls: false,
                  progress: false,
                  slideNumber: false,
                })"
            >
              Use new preset configuration
            </button>
          </section>
          <section id="themes">
            <h2>Themes</h2>

            <p>reveal.js ships with a couple of built-in themes: <br /></p>

            <ul
              id="themes-list"
              style="column-count: 2; column-gap: 1.5em"
            ></ul>

            <p><small>*default theme used in these slides</small></p>

            <p>
              <small>
                <strong>Change theme back to default before proceeding</strong>
                <br />
                is recommended for consistent styling
              </small>
            </p>

            <script>
              function setupThemesList() {
                const themesListElement =
                  document.getElementById("themes-list");

                const themesDark = [
                  "night",
                  "black",
                  "blood",
                  "moon",
                  "league",
                ];
                const themesLight = [
                  "sky",
                  "solarized",
                  "serif",
                  "beige",
                  "white",
                ];
                const themes = [...themesDark, ...themesLight];

                themes.forEach((themeName) => {
                  const listItem = document.createElement("li");

                  const a = document.createElement("a");
                  a.href = "javascript:void(0)";
                  const themeCssUrl = `https://cdnjs.cloudflare.com/ajax/libs/reveal.js/4.4.0/theme/${themeName}.min.css`;
                  a.onclick = () => setTheme(themeCssUrl);
                  a.text = themeName;

                  if (themeName === "black") {
                    a.text += "*";
                  }

                  listItem.appendChild(a);
                  themesListElement.appendChild(listItem);
                });
              }

              function setTheme(themeCssUrl) {
                const linkRel = document.getElementById("theme");
                linkRel.setAttribute("href", themeCssUrl);
              }

              setupThemesList();
            </script>
          </section>
        </section>

        <section>
          <section
            data-background-iframe="https://revealjs.com/backgrounds/#iframe-backgrounds"
            data-preload
            id="slide-background-iframe"
          >
            <div
              id="background-iframe-description"
              style="
                background-color: rgba(0, 0, 0, 0.9);
                box-shadow: 2px 2px 5px black;
                color: white;
                cursor: move;
                font-size: 20px;
                padding: 2rem;
                position: absolute;
                left: calc(50% - 12rem);
                text-align: left;
                user-select: none;
                width: 24rem;
              "
            >
              <h2>Iframe backgrounds</h2>

              <p>
                The embedded page can be interacted with, and is a great way for
                quick demos
              </p>
              <p>
                Click in this section to return focus to the presentation
                (re-enables presentation keyboard shortcuts)
              </p>
              <p>This overlay can be moved by dragging</p>
            </div>

            <script>
              function setupDraggableElement(element) {
                const onElementMouseDown = (e) => {
                  initialX = e.clientX;
                  initialY = e.clientY;

                  document.onmouseup = resetDocumentHandlers;
                  document.onmousemove = onElementDrag;
                };

                const onElementDrag = (e) => {
                  e.preventDefault();

                  const offsetX = Math.round(
                    (initialX - e.clientX) / Reveal.getScale()
                  );
                  const offsetY = Math.round(
                    (initialY - e.clientY) / Reveal.getScale()
                  );

                  element.style.top = `${element.offsetTop - offsetY}px`;
                  element.style.left = `${element.offsetLeft - offsetX}px`;

                  initialX = e.clientX;
                  initialY = e.clientY;
                };

                const resetDocumentHandlers = () => {
                  document.onmouseup = null;
                  document.onmousemove = null;
                };

                let initialX = 0;
                let initialY = 0;
                element.onmousedown = onElementMouseDown;
              }

              const iframeDescriptionContainer = document.getElementById(
                "background-iframe-description"
              );
              setupDraggableElement(iframeDescriptionContainer);
            </script>
          </section>
          <section
            data-background="https://picsum.photos/seed/background-1/480/270"
            data-background-opacity="0.1"
            id="slide-background-image"
          >
            <div
              style="
                color: white;
                padding: 2rem;
                border-radius: 8px;
                border: 2px solid hsl(120, 100%, 25%);
              "
            >
              <h2>Image backgrounds</h2>

              <pre>
                <code class="hljs html" data-trim data-line-numbers>
                  <script type="text/template">
                    <section
                      data-background="image.jpg"
                      data-background-opacity="0.1"
                    >
                  </script>
                </code>
              </pre>
            </div>
          </section>
          <section
            data-background="linear-gradient(#303030, hsl(150, 100%, 25%))"
            id="slide-background-css"
          >
            <h2>Slide backgrounds</h2>

            <p>
              Set <code>data-background</code> attribute on
              <code>&lt;section></code>
              <br />
              to change the background
            </p>

            <pre>
              <code class="hljs html" data-trim data-line-numbers>
                <script type="text/template">
                  <section
                    data-background="linear-gradient(#303030, hsl(150, 100%, 25%))">
                </script>
              </code>
            </pre>
          </section>
        </section>

        <section id="embed-youtube">
          <h2 class="r-fit-text">Embedded YouTube videos</h2>

          <p>
            <span style="color: #2090ff">Listen</span> to the audio and
            <span style="color: #2090ff">pan around</span> the video
          </p>

          <iframe
            width="640"
            height="360"
            data-src="https://www.youtube.com/embed/jh429pgBtag"
            title="[Demo] 360° video with distinct spatial audio"
            frameborder="0"
            allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"
            allowfullscreen
            referrerpolicy="no-referrer"
            data-preload
          ></iframe>
        </section>

        <section>
          <section id="presenter-view">
            <h2>Presenter view</h2>

            <p>Press <kbd>S</kbd> to open presenter view</p>

            <p>
              You may need to enable popups for this page
              <br />
              and use the keyboard shortcut again
            </p>

            <aside class="notes">
              <p>Slide notes are shown here.</p>

              <p>
                By default, the left pane is the current slide (useful if you
                use a second monitor) and top-right pane is a preview of the
                next slide (for segues).
              </p>

              <p>Click on the stopwatch to reset.</p>
            </aside>
          </section>
          <section id="break">
            <h2>Break</h2>

            <p class="r-fit-text">
              Press <kbd>B</kbd> to take a break and hide the slides from screen
            </p>
          </section>
          <section id="slides-overview">
            <h2>Slides overview</h2>

            <p>Press <kbd>Esc</kbd> to enter overview mode</p>
            <p><small>Navigate with arrow keys as usual</small></p>

            <button
              onclick="Reveal.toggleOverview()"
              style="cursor: pointer; padding: 1rem"
            >
              Enter overview mode
            </button>
          </section>
        </section>

        <section id="pdf-export">
          <h2>PDF export</h2>

          <p>
            Presentations can be
            <a
              href="https://revealjs.com/pdf-export/#instructions"
              rel="noopener noreferrer"
              >exported to PDF</a
            >
            (or printed)
          </p>

          <ol>
            <li>
              Set the query string to
              <a href="?print-pdf" target="_blank"><code>?print-pdf</code></a>
              <br />
              for print-friendly CSS
            </li>

            <li>
              Print using the system dialog (<kbd>Ctrl</kbd>+<kbd>P</kbd>)
            </li>
          </ol>
        </section>

        <section data-visibility="uncounted">
          <h1 class="r-fit-text r-frame" style="padding: 75px 100px 75px 100px">
            The end
          </h1>
        </section>
      </div>
    </div>

    <script
      src="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/4.4.0/reveal.min.js"
      integrity="sha512-uQGK5PLqAxTaCXSpiQXLYo93HzIRCBUek4jab5gDky9RN621pYpOh1oSxfmG301wW6OU4s8Bk0JDfi77JMZRuQ=="
      crossorigin="anonymous"
      referrerpolicy="no-referrer"
    ></script>

    <script
      src="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/4.4.0/plugin/highlight/highlight.min.js"
      integrity="sha512-PrMZUaiqYqRQyi4D71cIxqg/nyiclXEBLlR6A76tQP81iq6vrz9DBa+vLkn2efw3ECfYbKH1G+uLLpq6ZZ4dLA=="
      crossorigin="anonymous"
      referrerpolicy="no-referrer"
    ></script>
    <script
      src="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/4.4.0/plugin/markdown/markdown.min.js"
      integrity="sha512-ik0i3CQNgrNfRPUyZGlVqKGpxWR//UV0Y+4y6FHeHvaX/T/TM2nLyjCDQr6Nl/VZrNF8zjkiQ/YL0bsT9GsbVQ=="
      crossorigin="anonymous"
      referrerpolicy="no-referrer"
    ></script>
    <script
      src="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/4.4.0/plugin/math/math.min.js"
      integrity="sha512-skPZpuRwuUAnF9iEEFBXc4zJaucKcHUDgY1wDBTv0ILy82C2gn8MJsbcinzj2u8r/iZjD/78HRgw2/n//poOhQ=="
      crossorigin="anonymous"
      referrerpolicy="no-referrer"
    ></script>
    <script
      src="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/4.4.0/plugin/notes/notes.min.js"
      integrity="sha512-zT7Fnv76+94Gjt8yB3Y5zxJrfhA9BLafFepaO2ywAhKnPIrj/HWEmQqybnop+Z6h1St1QlQwiddrsPial8AjJw=="
      crossorigin="anonymous"
      referrerpolicy="no-referrer"
    ></script>
    <script
      src="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/4.4.0/plugin/search/search.min.js"
      integrity="sha512-ulzmAOS4jBVY0CuKQsrgalWWJOW01ZJ32llxKraQE+TZhxGGQJxPWlqDJZkWiPm3FPexfHNkxEcYnEjElU+vvw=="
      crossorigin="anonymous"
      referrerpolicy="no-referrer"
    ></script>

    <script src="revealjs-plugins/menu.js"></script>

    <script>
      // Docs: https://revealjs.com/config/
      Reveal.initialize({
        controlsBackArrows: "visible",
        controlsLayout: "edges",
        hash: true,
        hideCursorTime: 1000,
        katex: {
          // Warning: automatically loaded from https://cdn.jsdelivr.net
          version: "0.16.4",
        },
        maxScale: 1, // Prevent scaling up, which causes blurry text in code snippets on some browsers
        pdfSeparateFragments: false,
        plugins: [
          RevealMarkdown, // Must appear before RevealHighlight otherwise code snippets in Markdown aren't highlighted
          RevealHighlight,
          RevealMath.KaTeX,
          RevealMenu,
          RevealNotes, // Presenter mode
          RevealSearch,
        ],
        slideNumber: "c/t",
        transition: "convex",
        transitionSpeed: "fast",

        // Docs: https://github.com/denehyg/reveal.js-menu/blob/2.1.0/README.md#configuration
        menu: {
          numbers: "h.v",
          openSlideNumber: true,
          sticky: true,
        },
      });
    </script>
  </body>
</html>
